%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%  This file is part of Logtalk <https://logtalk.org/>
%  SPDX-FileCopyrightText: 1998-2023 Paulo Moura <pmoura@logtalk.org>
%  SPDX-License-Identifier: Apache-2.0
%
%  Licensed under the Apache License, Version 2.0 (the "License");
%  you may not use this file except in compliance with the License.
%  You may obtain a copy of the License at
%
%      http://www.apache.org/licenses/LICENSE-2.0
%
%  Unless required by applicable law or agreed to in writing, software
%  distributed under the License is distributed on an "AS IS" BASIS,
%  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
%  See the License for the specific language governing permissions and
%  limitations under the License.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


:- object(streams).

	:- info([
		version is 0:1:0,
		author is 'Gopal Gupta et al. Adapted to Logtalk by Paulo Moura.',
		date is 2010-07-23,
		comment is 'Coinduction infinite streams example.'
	]).

	:- public(nat_stream/1).
	:- coinductive(nat_stream/1).

	nat_stream([H| T]) :-
		nat(H),
		nat_stream(T).

	nat(0).
	nat(s(N)) :-
		nat(N).

	:- public(bit_stream/1).
	:- coinductive(bit_stream/1).

	bit_stream([H| T]) :-
		bit(H),
		bit_stream(T).

	bit(0).
	bit(1).

:- end_object.
